#
# setup.py
#

from distutils import util
from distutils.core import setup, Extension
import os, sys, shutil

__version__ = "0.6.7"
# create the version file
f = open("src/version.py", "wb")
f.write("""#
# version.py
#
# Copyright (C) Keyphrene 2002-2006, All rights reserved
#
__version__ = '"""+__version__+"""'
""")
f.close()


_ver = ".%s-%s" % (util.get_platform(), sys.version[0:3])
_build = os.path.join(os.getcwd(), "build/lib"+_ver+"/ssh2/")
_temp = os.path.join(os.getcwd(), "build/temp"+_ver+"/Release/")
print _build, _temp


# SSH Wrapper
ssh2_src = ['src/ssh2.c', 'src/session.c', 'src/channel.c', 
	'src/sftp.c', 'src/sftphandle.c', 'src/listener.c']
ssh2_dep = ['src/ssh2.h', 'src/session.h', 'src/channel.h',
	'src/sftp.h', 'src/sftphandle.h', 'src/listener.h']

Libraries = []
IncludeDirs = None
LibraryDirs = None
ExtraCompileArgs = None
ExtraLinkArgs = None

IncludeDirs = ['/usr/include','/usr/local/include']
LibraryDirs = ['/usr/include','/usr/local/include']
Libraries = ['ssl', 'crypto', 'ssh2', 'z']

ext_SSH2 = Extension('SSH2',
		sources = ssh2_src,
		depends = ssh2_dep,
		include_dirs = IncludeDirs, 
		library_dirs = LibraryDirs,
		libraries = Libraries,
		extra_compile_args = ExtraCompileArgs, 
		extra_link_args = ExtraLinkArgs)

ext_all_os_modules = [ext_SSH2]

setup(name='SSH2', version=__version__,
      package_dir = { 'SSH2': 'src/'},
      ext_modules = ext_all_os_modules,
      py_modules  = [],
      description = 'Wrapper LIBSSH2',
      author = 'Keyphrene.com', author_email = 'support@keyphrene.com,vincent.jaulin@keyphrene.com',
      url = 'http://www.keyphrene.com/',
      license = 'LGPL',
      long_description = """\
"""
     )

