/*
 * vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker:
 *
 * session.h
 *
 * Copyright (C) Keyphrene.com 2005, All rights reserved
 *
 *
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA


 */
#ifndef PySSH2_Session_H_
#define PySSH2_Session_H_

#include <Python.h>
#include "libssh2.h"

extern  int                 init_SSH2_Session       (PyObject *);

extern  PyTypeObject        SSH2_Session_Type;

#define SSH2_Session_Check(v) ((v)->ob_type == &SSH2_Session_Type)

typedef struct {
    PyObject_HEAD
    LIBSSH2_SESSION     *session;
    PyObject            *socket;
    PyThreadState       *tstate;
    int                 dealloc;
    int                 opened;
    int                 debug;
} SSH2_SessionObj;


#endif
