#!/usr/bin/env python

import os, sys, socket, time
import unittest, unittest_env

import SSH2

class SSH2FingerPrintUnitTest(unittest.TestCase):
	
	def getConnexion(self):
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.connect((HOSTNAME, PORT))
		sock.setblocking(1)
		return sock
	
	def testFingerPrintMD5(self):
		print "MD5"
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ssh.startup(self.getConnexion())
		#print SSH2.FINGERPRINT_SHA1
		#print SSH2.FINGERPRINT_MD5
		fingerprint = ssh.getFingerprint(SSH2.FINGERPRINT_MD5)
		hash = ""
		i = 0
		for chr in fingerprint:
				hash = hash + ("%2X" %ord(chr)).replace(" ","0")
				i += 1
		print("fingerprint MD5 " + hash + "\t" + str(i) + "chars" )
		ssh.close()
	
	def testFingerPrintSHA1(self):
		print "SHA1"
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ssh.startup(self.getConnexion())

		fingerprint = ssh.getFingerprint(SSH2.FINGERPRINT_SHA1)
		hash = ""
		i = 0
		for chr in fingerprint:
				hash = hash + ("%2X" %ord(chr)).replace(" ","0")
				i += 1
		print("fingerprint SHA1 " + hash + "\t" + str(i) + "chars" )
		ssh.close()

	
	def testFingerPrintDefault(self):
		print "DEFAULT"
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ssh.startup(self.getConnexion())
		#print SSH2.FINGERPRINT_SHA1
		#print SSH2.FINGERPRINT_MD5
		fingerprint = ssh.getFingerprint()
		hash = ""
		i = 0
		for chr in fingerprint:
				hash = hash + ("%2X" %ord(chr)).replace(" ","0")
				i += 1
		print("fingerprint (default to MD5) " + hash + "\t" + str(i) + "chars" )
		ssh.close()

if __name__ == "__main__": 
	print
	print "UnitTest: Foreign host fingerprint"
	HOSTNAME = "127.0.0.1"
	PORT = 22
	
	unittest.main()
