#!/usr/bin/env python

import os, sys, socket, time
import unittest, unittest_env

import SSH2

class SSH2FingerPrintUnitTest(unittest.TestCase):
	
	def getConnexion(self):
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.connect((HOSTNAME, PORT))
		sock.setblocking(1)
		return sock
	
	def testPopenNonBlocking(self):
		print "#########################"
		print "#"
		print "# test Popen Non Blocking"
		print "#"
		print "#########################"
		time.sleep(2)
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER)
		ssh.startup(self.getConnexion())
		ssh.setPassword(LOGIN, PWD)
		channel = ssh.popen(command)
		print channel
		l = 0
		el = 0
		outputfile = open("testPopenNonBlocking","wb")
		errorsfile = open("testPopenNonBlocking_err","wb")
		if channel:
			channel.setBlocking(False)
			while 1:
				if channel.eof():
					print "EOF"
				 	break
				if not channel.poll(100,[SSH2.LIBSSH2_POLLFD_POLLIN,SSH2.LIBSSH2_POLLFD_POLLPRI]):
					print "no data"
					raise Exception('File incomplete')
				data = channel.read(BUFFER) # BUF represente la quantite maximum de donnees, mais on recuperer moins
				if data:
					sys.stdout.write(data)
					outputfile.write(data)
					l += len(data)
				errors = None
				if channel.poll(10,[SSH2.LIBSSH2_POLLFD_POLLEXT]):
					errors = channel.readstderr(BUFFER)
					print "\nerror\n"
				if errors is not None:
					sys.stderr.write("Error" + errors)
					el += len(errors)
					errorsfile.write(errors)
		ssh.close()
		print "data lenght: %s\nerror lenght: %s" %(l,el)
		time.sleep(2)

	def testPopenNonBlockingWithErr(self):
		print "#########################"
		print "#"
		print "# Test: Popen Non Blocking With Error"
		print "#"
		print "#########################"
		time.sleep(2)
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER)
		ssh.startup(self.getConnexion())
		ssh.setPassword(LOGIN, PWD)
		channel = ssh.popen(command_err)
		outputfile = open("testPopenNonBlockingWithError","wb")
		errorsfile = open("testPopenNonBlockingWithError_err","wb")
		if channel:
			print channel
			channel.setBlocking(False)
			l = 0
			el = 0
			while 1:
				if channel.eof():
					print "EOF"
				 	break
				if not channel.poll(100,[SSH2.LIBSSH2_POLLFD_POLLIN,SSH2.LIBSSH2_POLLFD_POLLPRI]):
					print "no data"
					raise Exception('File incomplete')
				data = channel.read(BUFFER) # BUF represente la quantite maximum de donnees, mais on recuperer moins
				if data:
					sys.stdout.write(data)
					l += len(data)
					outputfile.write(data)
				errors = None
				if channel.poll(10,[SSH2.LIBSSH2_POLLFD_POLLEXT]):
					errors = channel.readstderr(BUFFER)
					print "\nerror\n"
				if errors:
					sys.stderr.write(errors)
					el += len(errors)
					errorsfile.write(errors)
				if channel.eof():
					print "EOF"
					break
		ssh.close()
		print "data lenght: %s\nerror lenght: %s" %(l,el)
		time.sleep(2)


	def testPopen(self):
		sys.exit(0)
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER)
		ssh.startup(self.getConnexion())
		ssh.setPassword(LOGIN, PWD)
		channel = ssh.popen(command)
		print channel
		if channel:
			channel.setBlocking(True)
			while 1:
				if channel.eof():
					print "EOF"
				 	break
				data = channel.read(BUFFER) # BUF represente la quantite maximum de donnees, mais on recuperer moins
				if data:
					sys.stdout.write(data)
				errors = None
				#if channel.poll(100,[SSH2.LIBSSH2_POLLFD_POLLEXT]):
				errors = channel.readstderr(BUFFER)
				if errors:
					sys.stderr.write(errors)
				if channel.eof():
					print "EOF"
				 	break
		ssh.close()
			
	def testPopenWithErr(self):
		#sys.exit(0)
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER)
		ssh.startup(self.getConnexion())
		ssh.setPassword(LOGIN, PWD)
		channel = ssh.popen(command_err)
		print channel
		if channel:
			channel.setBlocking(True)
			while 1:
				if channel.eof():
					print "EOF"
					channel.close()
				 	break
				data = channel.read(BUFFER) # BUF represente la quantite maximum de donnees, mais on recuperer moins
				if data:
					sys.stdout.write(data)
				errors = None
				#if channel.poll(100,[SSH2.LIBSSH2_POLLFD_POLLEXT]):
				#errors = channel.readstderr(BUFFER)
				if errors:
					sys.stderr.write(errors)
				if channel.eof():
					print "EOF"
					channel.close()
					break
		ssh.close()
	
	
if __name__ == "__main__": 
	print
	print "UnitTest: Foreign host fingerprint"
	HOSTNAME = "127.0.0.1"
	PORT = 22
	LOGIN = "tom"
	PWD = "********"
	BUFFER = 8192
	publickey = "/home/tom/.ssh/id_dsa.pub"
	privatekey = "/home/tom/.ssh/id_dsa"
	passphrase = "********"
	publickey_nopass = "/home/tom/.ssh/id_rsa.pub"
	privatekey_nopass = "/home/tom/.ssh/id_rsa"
	command = "cat xulu; cat mbox"
	command_err = "cat xulu; cat mbox; cat xulu"

	unittest.main()
